        .model large
        .CODE

PUBLIC  _reset
PUBLIC  _key
PUBLIC  _readbyte
PUBLIC  _writebyte 
PUBLIC  _readbytew
PUBLIC	_verdubbel

extrn   _capsstatus:byte
extrn   _keytab:byte

arg_org         equ     6       ; large model
PPI_ADDR        equ     308h

_readbyte       PROC
                PUSH    DX              ; save gebruikte registers
                mov     ah, 0
                MOV     DX,PPI_ADDR     ; laadt statusregister adres
		ADD     DX,2
		IN      AL,DX           ; lees statusregister
		TEST    AL,00100000B    ; test op input buffer full
		JZ      LEESBYTE1       ; spring indien geen byte ontvangen
		mov     ah, 0ffh        ; op -1 als er wat ontvangen is
		SUB     DX,2            ; poortadres verlagen
		IN      AL,DX           ; lees data
;               mov     al,0            ; wek de indruk goed te zijn
LEESBYTE1:      POP     DX              ; herstel dx register
		RET                     ; einde routine
_readbyte       ENDP

_readbytew      PROC
		PUSH    DX              ; save gebruikte registers
		mov     ah, 0           ;
LEESBYTE2:      MOV     DX,PPI_ADDR     ; laadt statusregister adres
		ADD     DX,2
		IN      AL,DX           ; lees statusregister
		TEST    AL,00100000B    ; test op input buffer full
		JZ      LEESBYTE2       ; spring indien geen byte ontvangen
		SUB     DX,2            ; poortadres verlagen
		IN      AL,DX           ; lees data
;               mov     al, 1           ; testje van ome leen
                POP     DX              ; herstel dx register
                RET                     ; einde routine
_readbytew      ENDP

_writebyte      PROC
argu    equ arg_org

		push    bp
		mov     bp, sp

		mov     ax, [bp+argu]   ; First argument
		PUSH    DX              ; Save gebruikte registers
                PUSH    AX
                MOV     DX,PPI_ADDR     ; Laadt adres statusregister
                ADD     DX,2
ZENDBYTE1:      IN      AL,DX           ; Lees statusregister
                TEST    AL,00000010B    ; Test op output buffer empty
                JZ      ZENDBYTE1       ; Spring als vorig teken niet gelezen
                DEC     DX              ; Poortadres verlagen
                POP     AX              ; Haal data van stack
                OUT     DX,AL           ; Verstuur data
                POP     DX              ; Herstel dx
		pop     bp
		RET                     ; Einde routine
_writebyte      ENDP

_reset          proc
		MOV     DX,PPI_ADDR     ; Laadt adres command register 8255
		ADD     DX,3
		push	dx
		mov	al, 0b4h	; Laadt de gegevens
		out	dx, al
		mov	al, 0fh
		out	dx, al
		pop	dx
		MOV     AL,0EH          ; Geef resetpuls
		OUT     DX,AL           ; PC7 Laag
		MOV     CX,00FFH        ; Wacht korte tijd
RESETPAUSE:     LOOP    RESETPAUSE
		MOV     AL,0FH          ;
		OUT     DX,AL           ; PC7 Hoog
		ret                     ; Terug jij
_reset          endp

_key            proc
                mov     ah, 2
                int     16h
                MOV     DX,0            ; Reset atom keyboard status byte
TST_SHIFT:      TEST    AL,00000011B    ; Test op shifttoets
		JE      TST_CTRL        ; Spring indien geen shifttoets
                OR      DL,10000000B    ; Zet shift bit
TST_CTRL:       TEST    AL,00000100B    ; Test op control toets
                JE      TST_ALT         ; Spring indien geen control toets
                OR      DL,01000000B    ; Zet control bit
TST_ALT:        TEST    AL,00001000B    ; Test op alt toets
                JE      TST_CAPS        ; Spring indien geen alt toets
                OR      DL,00100000B    ; Zet alt bit
TST_CAPS:       AND     AL,01000000B    ; Bepaal caps lock status
                CMP     AL,_capsstatus  ; Test op wisseling
                JE      TST_KEY         ; Spring indien gelijk
                MOV     _capsstatus,AL  ; Zet nieuwe caps lock status
                MOV     DH,43H          ; Laadt scancode voor capstoets
                OR      DL,00000001B    ; Zet toets vlag
                JMP     ENDKEY          ; Spring altijd

TST_KEY:        MOV     AH,1            ; Kijk of een toets in buffer is
                INT     16H
                JZ      ENDKEY          ; Spring indien geen toets gedrukt
		MOV     AH,0            ; Haal karakter uit buffer
                INT     16H

                CMP     AH,46H          ; Kijk of scancode boven 46h ligt
                JLE     NEWKEY          ; Nee, dan is niets aan de hand
                CMP     AL,00H          ; Test of numlock aan
                JE      NEWKEY          ; Ja, dan ook niets aan de hand
                ADD     AH,10H          ; Anders maak aanpassing
NEWKEY:         MOV     BL,AH           ; Zet scan code in indexregister
                MOV     BH,00H
                MOV     DH,_keytab[BX]  ; Zet nieuwe scancode in dl
                OR      DL,00000001B    ; Zet toets vlag

ENDKEY:         MOV     AL,DH           ; Stuur scan code naar atom
                MOV     AH,DL           ; Stuur statusbyte naar atom
                ret                     ; Naar house!
_key            endp

_verdubbel      proc
argu    equ arg_org

		push    bp
		mov     bp, sp

		mov     ax, [bp+argu]   ; First argument
		mov	bx, ax
		xor	ax, ax
		mov	cx,4
lusje:          clc
		shl	ax, 1
		shl	ax, 1
		shl	bl, 1
		shl	ax, 1
		shl	bl, 1
		shl	ax, 1
		loop	lusje

		pop     bp
		RET                     ; Einde routine

_verdubbel	endp
     END
