#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#include "watom.h"
#define IDM_RESET 201
#define IDM_TIMER 200
#define ALIGNLONG(i) ((i+3)/4*4)


#define min(a,b) (((a) < (b)) ? (a) : (b))
#define max(a,b) (((a) > (b)) ? (a) : (b))

#define BUFFER(x,y) *(pBuffer + y * cxBuffer + x)

void DrawBitmap(HDC, HBITMAP, short, short);

// HDC	hDC, hMemDC;
static BYTE	BitMapBits[24577];

long FAR PASCAL _export WndProc (HWND, UINT, UINT, LONG) ;
int PASCAL WinMain (HANDLE hInstance, HANDLE hPrevInstance,
                    LPSTR lpszCmdLine, int nCmdShow)
{
static char szAppName[] = "WinAtom" ;
HWND        hwnd ;
MSG         msg ;
WNDCLASS    wndclass ;

   if (!hPrevInstance) {
      wndclass.style         = CS_HREDRAW | CS_VREDRAW ;
      wndclass.lpfnWndProc   = WndProc ;
      wndclass.cbClsExtra    = 0 ;
      wndclass.cbWndExtra    = 0 ;
      wndclass.hInstance     = hInstance ;
      wndclass.hIcon         = LoadIcon (NULL, IDI_APPLICATION) ;
      wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW) ;
      wndclass.hbrBackground = (HBRUSH) GetStockObject (WHITE_BRUSH) ;
      wndclass.lpszMenuName =  "AtomMenu";   /* Name of menu resource in .res file. */
      wndclass.lpszClassName = szAppName ;

      RegisterClass (&wndclass) ;
      }

   hwnd = CreateWindow (szAppName, "Atom Outside", WS_OVERLAPPEDWINDOW,
            CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
	    NULL, NULL, hInstance, NULL) ;

   ShowWindow (hwnd, nCmdShow) ;

   UpdateWindow (hwnd) ;

   while (GetMessage(&msg, NULL, 0, 0)) {
      TranslateMessage (&msg) ;
      DispatchMessage (&msg) ;
      }
   return msg.wParam ;
}

long FAR PASCAL _export WndProc (HWND hWnd, UINT message, UINT wParam, LONG lParam)
{
int	i;
static  int k=0, q=0;
static BOOL	bFlag = FALSE;
PAINTSTRUCT	ps;
static HBITMAP 	hBitmap;
HDC		hdc;
static BITMAPINFOHEADER	Bi;
LPBITMAPINFOHEADER	lpbi;
static HANDLE		hDIB;
LPSTR			lpstBitmap, lpstTemp;
int			nBytes;
char		szTekst[50];

   switch (message) {
      case WM_CREATE:

	 hdc = GetDC(hWnd);
	 Bi.biSize = sizeof(BITMAPINFOHEADER);
	 Bi.biWidth = 256;
	 Bi.biHeight = 192;
	 Bi.biPlanes = 1;
   	 Bi.biBitCount = 4;
 //	 Bi.biBitCount = 1;
	 Bi.biCompression = BI_RGB;
	 Bi.biSizeImage = 256 * 192;
	 Bi.biXPelsPerMeter = 0;
	 Bi.biYPelsPerMeter = 0;
	 Bi.biClrUsed = 0;
	 Bi.biClrImportant = 0;

	 hBitmap = CreateDIBitmap(hdc, &Bi, 0L, NULL, NULL, 0);
	 hDIB = GlobalAlloc(GHND, sizeof(BITMAPINFOHEADER) +
	    16 * sizeof(RGBQUAD));
	 lpbi = (BITMAPINFOHEADER FAR *)GlobalLock(hDIB);
	 *lpbi = Bi;
	 GetDIBits(hdc, hBitmap, 0, 50, NULL, (LPBITMAPINFO) lpbi, DIB_RGB_COLORS);
	 GlobalUnlock(hDIB);
	 ReleaseDC(hWnd, hdc);
//	 SetTimer(hWnd, 1, 20, NULL);
	 break;
      case WM_COMMAND:
	 switch (wParam) {
	 int l, m;
	 case IDM_RESET:
	    lpbi = (BITMAPINFOHEADER FAR *) GlobalLock(hDIB);
	    k = q & 0x0f;
	    l = q & 0x0f;
	    l = k << 4;
            m = k | l;
	    for (i=0; i< 2 * 6144; i++)
	       BitMapBits[i]=m;
            q++;
	    hdc = GetDC(hWnd);
	    SetDIBits(hdc, hBitmap, 0, 192, (LPSTR) BitMapBits,
	       (LPBITMAPINFO) lpbi, DIB_RGB_COLORS);
	    ReleaseDC(hWnd, hdc);
            GlobalUnlock(hDIB);
	    bFlag = TRUE;
	    sprintf(szTekst, "de kop is: %d", q);
            SetWindowText(hWnd, szTekst);
	    InvalidateRect(hWnd, NULL, FALSE);
	    break;

	 }
	 break;

      case WM_TIMER:
		 q=k;
		 for (i=0; i< 2 * 6144; i++)
			 BitMapBits[i]=q++;
		 k++;
		 hdc = GetDC(hWnd);
		 lpbi = (BITMAPINFOHEADER FAR *) GlobalLock(hDIB);
		 SetDIBits(hdc, hBitmap, 0, 192, (LPSTR) BitMapBits,
			 (LPBITMAPINFO) lpbi, DIB_RGB_COLORS);
		 ReleaseDC(hWnd, hdc);
				GlobalUnlock(hDIB);
	    bFlag = TRUE;
	    InvalidateRect(hWnd, NULL, FALSE);
	 break;
// */
      case WM_PAINT:
	 BeginPaint(hWnd, &ps);
	 DrawBitmap(ps.hdc, hBitmap, 10, 10);
	 EndPaint(hWnd, &ps);
	 break;
//  */
      case WM_DESTROY:
         GlobalFree(hDIB);
	 PostQuitMessage(0);
	 break;
      default:
	 return DefWindowProc (hWnd, message, wParam, lParam) ;
      }
   return 0L;
}

void DrawBitmap(HDC hdc, HBITMAP hBitmap, short xStart, short yStart)
{
BITMAP	bm;
HDC	hMemDC;
DWORD	dwSize;
POINT	ptSize, ptOrg;

   hMemDC = CreateCompatibleDC(hdc);
   SelectObject(hMemDC, hBitmap);
   SetMapMode(hMemDC, GetMapMode(hdc));
   GetObject(hBitmap, sizeof(BITMAP), (LPSTR) &bm);
   ptSize.x =  bm.bmWidth;
   ptSize.y = bm.bmHeight;
   DPtoLP(hdc, &ptSize, 1);
   ptOrg.x = 0;
   ptOrg.y = 0;
   DPtoLP(hMemDC, &ptOrg, 1);

   BitBlt(hdc, xStart, yStart, ptSize.x, ptSize.y, hMemDC,
      ptOrg.x, ptOrg.y, SRCCOPY);
   DeleteDC(hMemDC);
}
